Subject: Re: bug#36870:

From: Ludovic Courtès <[email-masked]>
Date: Mon, 26 Aug 2019 12:11:56 +0200

Hi,

Bengt Richter <[email-masked]> skribis:

> On +2019-08-06 02:54:03 -0400, Mark H Weaver wrote:
>> Hi Bengt,
>> 
>> I'm sorry that I didn't have time to fully read your messages, but if I
>> understand correctly from my quick skimming, the 'date' command from
>> Guix is failing to access the zoneinfo.  I think I see your problem.
>> 
>> Bengt Richter <[email-masked]> writes:
>> > $ strace -y date|& egrep 'America|^write'|sed -e 's:,:,\n    :g'
>> > openat(AT_FDCWD,
>> >      "/gnu/store/h90vnqw0nwd0hhm1l5dgxsdrigddfmq4-glibc-2.28/share/zoneinfo/America/Los_Angeles",
>> >      O_RDONLY|O_CLOEXEC) = -1 ENOENT (No such file or directory)
>> 
>> The file name above suggests that your TZDIR variable is not set
>> correctly to allow Guix-built binaries to find the zoneinfo files.
>> 
>> On Guix systems, /etc/environment includes an entry that sets TZDIR to
>> the equivalent of "$(guix build tzdata)/share/zoneinfo".
>> 
>> When using Guix on top of another distro, an alternative choice might be
>> to set TZDIR to "/usr/share/zoneinfo".  I'm not sure which setting is
>> preferable on non-Guix systems.
>> 
>> Can you try setting TZDIR and see if that solves the problem for you?
>> 
>>      Regards,
>>        Mark
>
> Thanks, that works using either /usr/... or /gnu/...

Good, closing!

> but I am thinking everything guix should be accessed via
> some profile if it's configurable?
>
> There is already a suggestion to source like this:
>
> GUIX_PROFILE="$HOME/.guix-profile"
> . "$GUIX_PROFILE/etc/profile"
>
> I think it would be nice if that were the only ~/.bash_profile
> mod a foreign-system user would have to make to tie into the
> guix packages such user installs with guix install.
>
> So what about having that GUIX_PROFILE profile -- at its end --
> source ~/.guixrc if it exists, and then when some installation wants
> to suggest some environment settings, just automatically
> append commented-out code to ~/.guixrc.

I agree that it’d be nice to somehow tell users about ‘TZDIR’, but I’m
reluctant to introducing yet another profile file.

I’m not sure what would be the best approach!

Thanks,
Ludo’.